local base = require "obj/base"
local zombie = class("zombie",base)

local path = "res/anim/mon2.png"
zombie.stateData = require "obj/roles/mon1State"
zombie.animAtlas = love.graphics.newImage(path)

zombie.animData = {
	{"idle",1,1,4},
	{"walk",1,2,4},
	{"attack",1,3,4},
	{"hurt",1,4,3},
	{"die",4,4,5},
	{"transform",1,6,6},
	{"fly",6,6,2},
}

	

function zombie:resetParameter()
	self.w = 16	
	self.h = 40
	self.offy = 4
	self.tw = 64
	self.th = 64
	self.ax = 1
	self.ay = 0.8
	self.speed = 1
	self.direction = 1
	self.scale = 1.5
	self.flipX = false
	self.isMonster = true
	self.hp = 50
	self.damage = 15
	self.price = 2
end

function zombie.collidefilter(me,other)
	if other.isPlayer then
		return "cross"
	elseif other.isMonster then
		return "cross"
	elseif other.isWall then
		return "slide"
	end
end


function zombie:collision(cols)
	for i,col in ipairs(cols) do
		local other = col.other
		if other.isWall then
			if col.normal.y == -1 then
				self.onGround = true
				self.dy = 0
			else
				self.direction = - self.direction
				self.flipX = not self.flipX
			end
		else
			
		end
	end
end

return zombie
