local menu = {}

function menu:init(stage)
	self.stage = stage

	self.style = {
		font = font,
		fgColor = "#FFFFFF",
		bgColor = "#25AAE1F0",
        mode3d = true,
        glass = true,
        round = .18,
	}
	gooi.setStyle(self.style)
	gooi.desktopMode()
	self:makeGrid()
	return self
end



local items = {
	"Rambo FirstAid Kit",
	function(stage,cat) return 50+stage.waveManager.waveCount * 10 end,
	function(stage,cat) cat.hp = cat.hpMax end,
	"Rambo Stanima Upgrade",
	"Rambo SelfRecovery Upgrade",
	"Pistol Damage Upgrade",
	"Pistol FireRate Upgrade",
	"Pistol Accuracy Upgrade",
	"MachineGun Magazine x100",100,function(cat) cat.weapon.machinegun.count =  cat.weapon.machinegun.count + 100 end,
	"MachineGun Damage Upgrade",
	"MachineGun Accuracy Upgrade",
	"ShotGun Magazine x20",
	"ShotGun Fragment Upgrade",
	"ShotGun Power Upgrade",
	"SnipeRifle Magazine x10",
	"SnipeRifle AimSpeed Upgrade",
	"SnipeRifle Recoil Upgrade",
	"Grenade Package x5",
	"Grenade Fragment Upgrade",
	"Grenade Power Upgrade",
}

local boxes = {
	{"Machinegun +100" ,function(stage,cat) cat.weapons[2].count = cat.weapons[2].count + 100 end },
	{"Shotgun + 20",function(stage,cat) cat.weapons[4].count = cat.weapons[4].count + 20 end },
	{"Sniperifle + 10",function(stage,cat) cat.weapons[3].count = cat.weapons[3].count + 10 end},
	{"Grenade + 5",function(stage,cat) cat.weapons[5].count = cat.weapons[5].count + 5 end},
	{"HP full recovered",function(stage,cat) cat.hp = cat.hpMax end},
}


function menu:addLine(i,tab)
	self.grid:setColspan(i+2, 1, 2)
	local title = gooi.newLabel({text = tab[1], orientation = "center",opaque = true}):bg("#111111")
	local unitPrice = gooi.newLabel({text = "100$", orientation = "center",opaque = true}):bg("#111111")
	local buy = gooi.newButton({text = "buy", orientation = "center"}):bg("#ff8800")
	buy:onPress(function(obj)
		local cat = self.stage.cat
		if cat.money >= 100 then
			cat.money = cat.money - 100
			tab[2](self.stage,cat)
			self.stage:newMessage(tab[1])
			playSound("getitem")
		end
	end)
	self.grid:add(title,unitPrice,buy)	
end

function menu:makeGrid()
	self.gridItem = {}
	self.grid = gooi.newPanel(400, 100, 500, 300, "grid 8x4")	
	self.grid:setColspan(1, 1, 4):setColspan(2, 1, 2)
	:add(
		gooi.newLabel({text = "Rambo's depot", orientation = "center"}),
		gooi.newLabel({text = "object", orientation = "center",opaque = true}),
		gooi.newLabel({text = "price", orientation = "center",opaque = true}),
		gooi.newLabel({text = "settle", orientation = "center",opaque = true})
	)
	for i,v in ipairs(boxes) do
		self:addLine(i,v)
	end
	self.grid:setVisible(false)
end


function menu:update(dt)
	gooi.update(dt)
end

function menu:draw()
	gooi.draw()
end

return menu